c  rk4_step.f
c  Rungova-Kuttova metoda 4. radu, 1 krok.
c  Miroslav Broz (miroslav.broz@email.cz), Oct 1st 2008

      subroutine rk4_step(n, t, r, v, h, f)

      implicit none
      include "common.inc"
      integer n
      double precision t, r(3*n), v(3*n), h, tstop
      external f
      integer i
      double precision k1(3*n), k2(3*n), k3(3*n), k4(3*n)
      double precision tp, rp(3*n), vp(3*n), h2

      call f(n, t, r, v, k1)
      h2 = h*h
      tp = t + 0.5*h
      do i = 1, 3*n
        vp(i) = v(i) + k1(i)*h*0.5                      ! tj. jako v = v0 + a*t
        rp(i) = r(i) + v(i)*h*0.5 + k1(i)*h2*0.125      ! s = s0 + v0*t + 1/2*a*t^2
      enddo
      call f(n, tp, rp, vp, k2)
      do i = 1, 3*n
        vp(i) = v(i) + k2(i)*h*0.5
        rp(i) = r(i) + v(i)*h*0.5 + k2(i)*h2*0.125
      enddo
      call f(n, tp, rp, vp, k3)
      tp = t + h
      do i = 1, 3*n
        vp(i) = v(i) + k3(i)*h
        rp(i) = r(i) + v(i)*h + k3(i)*h2*0.5
      enddo
      call f(n, tp, rp, vp, k4)

      do i = 1, 3*n
c  toto by bylo ekvivalentni  r(i) = r(i) + h/6. * (v1(i) + 2*v2(i) + 2*v3(i) + v4(i))
        r(i) = r(i) + v(i)*h + h2/6. * (k1(i) + k2(i) + k3(i))
        v(i) = v(i) + h/6. * (k1(i) + 2*(k2(i) + k3(i)) + k4(i))
      enddo
 
      return
      end


